c last modified 1/19/96

      subroutine iof(itype,vector,n,iun)
c I/O facility to read and write vectors of any size using
c large buffer, thus increasing unformatted i/o speed.
c
c itype  - operation type, as in the parameter statement below,
c vector - contains data to be stored or retrieved,
c      n - size of vector,
c    iun - unit number.
c
c If the data is small enough to fit in the buffer, subsequent reads
c are done entirely in memory with a RAM speed. Option "iopen" creates
c a temporary file. Definition of a named file should be done explicitly
c in a user program, followed by a call to this subroutine with "irew"
c option.
c
c For greater speed the subroutine should be used with one file only.
c More copies of it with different names (iof1,iof2...) can be used if
c more files are desired.
c
      parameter(irew=1,iopen=2,iwrite=3,iread=4)
      implicit integer (b,f,i)
      parameter(bufs=16384)
      integer x(bufs),vector(n)
      save x,fpos,bpos,iwr,lastit
      data fpos,bpos/2*-1/
***********************************************************************
      if(itype.eq.iread) then
        iwr=0
        if (fpos.eq.0) then
          read(iun,end=50)x
          fpos=1
          bpos=0
        endif
        n1=min(n,bufs-bpos)
        do 30 i=1,n1
30        vector(i)=x(bpos+i)
        bpos=bpos+n1
        if (bpos.eq.bufs .and. n1.ne.n) then
          read(iun,end=50)x
          fpos=fpos+1
          bpos=n-n1
          do 40 i=1,bpos
40          vector(i+n1)=x(i)
          endif
*
      else if(itype.eq.iwrite) then
        if (lastit.eq.irew) then
          fpos=0
          rewind iun
        endif
        iwr=1
        n1=min(n,bufs-bpos)
        do 10 i=1,n1
10      x(bpos+i)=vector(i)
        bpos=bpos+n1
        if (bpos.eq.bufs) then
          write(iun)x
          fpos=fpos+1
          bpos=n-n1
          do 20 i=1,bpos
20          x(i)=vector(i+n1)
        endif
*
      elseif (itype.eq.iopen) then
        bpos=0
        fpos=0
        open(iun,access='sequential',form='unformatted')
*
      else if (itype.eq.irew) then
        if (bpos.ne.0 .and. iwr.eq.1) then
          write(iun)x
          fpos=fpos+1
        endif
        iwr=0
        bpos=0
        if (fpos.ne.1) then
          fpos=0
          rewind iun
        endif
*
      else
        write(*,*)'unknown i/o code=',itype
        stop
      endif
***********************************************************************
      lastit=itype
      return
50    write(*,*)'end of file',iun
      write(*,*)'bpos,fpos,n',bpos,fpos,n
      stop
      end

      subroutine iof1(itype,vector,n,iun)
      parameter(irew=1,iopen=2,iwrite=3,iread=4)
      implicit integer (b,f,i)
      parameter(bufs=16384)
      integer x(bufs),vector(n)
      save x,fpos,bpos,iwr,lastit
      data fpos,bpos/2*-1/
***********************************************************************
      if(itype.eq.iread) then
        iwr=0
        if (fpos.eq.0) then
          read(iun,end=50)x
          fpos=1
          bpos=0
        endif
        n1=min(n,bufs-bpos)
        do 30 i=1,n1
30        vector(i)=x(bpos+i)
        bpos=bpos+n1
        if (bpos.eq.bufs .and. n1.ne.n) then
          read(iun,end=50)x
          fpos=fpos+1
          bpos=n-n1
          do 40 i=1,bpos
40          vector(i+n1)=x(i)
          endif
*
      else if(itype.eq.iwrite) then
        if (lastit.eq.irew) then
          fpos=0
          rewind iun
        endif
        iwr=1
        n1=min(n,bufs-bpos)
        do 10 i=1,n1
10      x(bpos+i)=vector(i)
        bpos=bpos+n1
        if (bpos.eq.bufs) then
          write(iun)x
          fpos=fpos+1
          bpos=n-n1
          do 20 i=1,bpos
20          x(i)=vector(i+n1)
        endif
*
      elseif (itype.eq.iopen) then
        bpos=0
        fpos=0
        open(iun,access='sequential',form='unformatted')
*
      else if (itype.eq.irew) then
        if (bpos.ne.0 .and. iwr.eq.1) then
          write(iun)x
          fpos=fpos+1
        endif
        iwr=0
        bpos=0
        if (fpos.ne.1) then
          fpos=0
          rewind iun
        endif
*
      else
        write(*,*)'unknown i/o code=',itype
        stop
      endif
***********************************************************************
      lastit=itype
      return
50    write(*,*)'end of file',iun
      write(*,*)'bpos,fpos,n',bpos,fpos,n
      stop
      end

      subroutine iof2(itype,vector,n,iun)
      parameter(irew=1,iopen=2,iwrite=3,iread=4)
      implicit integer (b,f,i)
      parameter(bufs=16384)
      integer x(bufs),vector(n)
      save x,fpos,bpos,iwr,lastit
      data fpos,bpos/2*-1/
***********************************************************************
      if(itype.eq.iread) then
        iwr=0
        if (fpos.eq.0) then
          read(iun,end=50)x
          fpos=1
          bpos=0
        endif
        n1=min(n,bufs-bpos)
        do 30 i=1,n1
30        vector(i)=x(bpos+i)
        bpos=bpos+n1
        if (bpos.eq.bufs .and. n1.ne.n) then
          read(iun,end=50)x
          fpos=fpos+1
          bpos=n-n1
          do 40 i=1,bpos
40          vector(i+n1)=x(i)
          endif
*
      else if(itype.eq.iwrite) then
        if (lastit.eq.irew) then
          fpos=0
          rewind iun
        endif
        iwr=1
        n1=min(n,bufs-bpos)
        do 10 i=1,n1
10      x(bpos+i)=vector(i)
        bpos=bpos+n1
        if (bpos.eq.bufs) then
          write(iun)x
          fpos=fpos+1
          bpos=n-n1
          do 20 i=1,bpos
20          x(i)=vector(i+n1)
        endif
*
      elseif (itype.eq.iopen) then
        bpos=0
        fpos=0
        open(iun,access='sequential',form='unformatted')
*
      else if (itype.eq.irew) then
        if (bpos.ne.0 .and. iwr.eq.1) then
          write(iun)x
          fpos=fpos+1
        endif
        iwr=0
        bpos=0
        if (fpos.ne.1) then
          fpos=0
          rewind iun
        endif
*
      else
        write(*,*)'unknown i/o code=',itype
        stop
      endif
***********************************************************************
      lastit=itype
      return
50    write(*,*)'end of file',iun
      write(*,*)'bpos,fpos,n',bpos,fpos,n
      stop
      end
      subroutine creatres(r)
c compute residuals for different classes of missing s-d combinations
      real r(0:255),varf(8,8),b(8),b1(8)
      integer i,j,k
c define  b and varf
      data b/4*.5,4*-.25/
      data varf/ 1.0,  .0,  .25, .25, .5,  .0,  .5,  .0,
     +            .0, 1.0,  .25, .25, .0,  .5,  .0,  .5,
     +            .25, .25,1.0,  .0,  .5,  .5,  .0,  .0,
     +            .25, .25, .0, 1.0,  .0,  .0,  .5,  .5,
     +            .5,  .0,  .5,  .0, 1.0,  .0,  .0,  .0,
     +            .0,  .5,  .5,  .0,  .0, 1.0,  .0,  .0,
     +            .5,  .0,  .0,  .5,  .0,  .0, 1.0,  .0,
     +            .0,  .5,  .0,  .5,  .0,  .0,  .0, 1.0/
c
       do i=255,0,-1
          do j=1,8
             if (btest(i,j-1)) then
                 b1(j)=b(j)
                else
                 b1(j)=0
             endif
          enddo
          r(i)=0
          do j=1,8
             do k=1,8
                r(i)=r(i)+b1(j)*varf(j,k)*b1(k)
             enddo
          enddo
          if (r(i).ge..9999) then
              r(i)=0
            else
              r(i)=1/(1-r(i))
          endif
      enddo
c print
c     print '('' r''/,100(15f5.2/))',(r(i),i=1,255)
      end


      subroutine invert(n,x,m)
c invert x of nxn declared as mxm; based on NUMERICAL RECIPIES
      integer n,m,i,j
      real*8 x(m,m),y(10,10),scr(10),d
c
      do i=1,n
         do j=1,n
            y(i,j)=x(i,j)
            x(i,j)=0
         enddo
         x(i,i)=1
      enddo
c
      call ludcmp(y,n,10,scr,d)
      do i=1,n
         call lubksb(y,n,10,scr,x(1,i))
      enddo
      end

      SUBROUTINE LUDCMP(A,N,NP,INDX,D)
      PARAMETER (NMAX=100,TINY=1.0E-20)
      real*8 A(NP,NP),INDX(N),VV(NMAX),d
      D=1.
      DO 12 I=1,N
        AAMAX=0.
        DO 11 J=1,N
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))
11      CONTINUE
        IF (AAMAX.EQ.0.) PAUSE 'Singular matrix.'
        VV(I)=1./AAMAX
12    CONTINUE
      DO 19 J=1,N
        IF (J.GT.1) THEN
          DO 14 I=1,J-1
            SUM=A(I,J)
            IF (I.GT.1)THEN
              DO 13 K=1,I-1
                SUM=SUM-A(I,K)*A(K,J)
13            CONTINUE
              A(I,J)=SUM
            ENDIF
14        CONTINUE
        ENDIF
        AAMAX=0.
        DO 16 I=J,N
          SUM=A(I,J)
          IF (J.GT.1)THEN
            DO 15 K=1,J-1
              SUM=SUM-A(I,K)*A(K,J)
15          CONTINUE
            A(I,J)=SUM
          ENDIF
          DUM=VV(I)*ABS(SUM)
          IF (DUM.GE.AAMAX) THEN
            IMAX=I
            AAMAX=DUM
          ENDIF
16      CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,N
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
17        CONTINUE
          D=-D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
        IF(J.NE.N)THEN
          IF(A(J,J).EQ.0.)A(J,J)=TINY
          DUM=1./A(J,J)
          DO 18 I=J+1,N
            A(I,J)=A(I,J)*DUM
18        CONTINUE
        ENDIF
19    CONTINUE
      IF(A(N,N).EQ.0.)A(N,N)=TINY
      RETURN
      END



      SUBROUTINE LUBKSB(A,N,NP,INDX,B)
      real*8 A(NP,NP),INDX(N),B(N)
      II=0
      DO 12 I=1,N
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
            SUM=SUM-A(I,J)*B(J)
11        CONTINUE
        ELSE IF (SUM.NE.0.) THEN
          II=I
        ENDIF
        B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
        SUM=B(I)
        IF(I.LT.N)THEN
          DO 13 J=I+1,N
            SUM=SUM-A(I,J)*B(J)
13        CONTINUE
        ENDIF
        B(I)=SUM/A(I,I)
14    CONTINUE
      RETURN
      END

      FUNCTION RAN1(IDUM)
c returns random value from 0 to 1; new seed if idum<-0; from Numerical Recipies.
      DIMENSION R(97)
      PARAMETER (M1=259200,IA1=7141,IC1=54773,RM1=3.8580247E-6)
      PARAMETER (M2=134456,IA2=8121,IC2=28411,RM2=7.4373773E-6)
      PARAMETER (M3=243000,IA3=4561,IC3=51349)
      DATA IFF /0/
      save
      IF (IDUM.LT.0.OR.IFF.EQ.0) THEN
        IFF=1
        IX1=MOD(IC1-IDUM,M1)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX2=MOD(IX1,M2)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX3=MOD(IX1,M3)
        DO 11 J=1,97
          IX1=MOD(IA1*IX1+IC1,M1)
          IX2=MOD(IA2*IX2+IC2,M2)
          R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
11      CONTINUE
        IDUM=1
      ENDIF
      IX1=MOD(IA1*IX1+IC1,M1)
      IX2=MOD(IA2*IX2+IC2,M2)
      IX3=MOD(IA3*IX3+IC3,M3)
      J=1+(97*IX3)/M3
      IF(J.GT.97.OR.J.LT.1)PAUSE
      RAN1=R(J)
      R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
      RETURN
      END


      FUNCTION RAN3(IDUM)
c returns random value from 0 to 1; new seed if idum<-0; from Numerical Recipies.
      IMPLICIT REAL*4(M)
      PARAMETER (MBIG=1000000000,MSEED=161803398,MZ=0,FAC=1.E-9)
      DIMENSION MA(55)
      DATA IFF /0/
      save
      IF(IDUM.LT.0.OR.IFF.EQ.0)THEN
        IFF=1
        MJ=MSEED-IABS(IDUM)
        MJ=MOD(MJ,MBIG)
        MA(55)=MJ
        MK=1
        DO 11 I=1,54
          II=MOD(21*I,55)
          MA(II)=MK
          MK=MJ-MK
          IF(MK.LT.MZ)MK=MK+MBIG
          MJ=MA(II)
11      CONTINUE
        DO 13 K=1,4
          DO 12 I=1,55
            MA(I)=MA(I)-MA(1+MOD(I+30,55))
            IF(MA(I).LT.MZ)MA(I)=MA(I)+MBIG
12        CONTINUE
13      CONTINUE
        INEXT=0
        INEXTP=31
        IDUM=1
      ENDIF
      INEXT=INEXT+1
      IF(INEXT.EQ.56)INEXT=1
      INEXTP=INEXTP+1
      IF(INEXTP.EQ.56)INEXTP=1
      MJ=MA(INEXT)-MA(INEXTP)
      IF(MJ.LT.MZ)MJ=MJ+MBIG
      MA(INEXT)=MJ
      RAN3=MJ*FAC
      RETURN
      END
